import React, { useEffect, useState } from 'react';

import MapObject from './map-object';

import { get } from '../utils/request';

// import JSON
import jsonOsmQuery from '../osm-query.json';

export default function JsonOsmQuery(){

    const rryOsmQuery = jsonOsmQuery.queries;
    console.log('rry.lngth: ' + rryOsmQuery.length);

    const [mp, setMp] = useState(null);

    /*fetch array in a JavaScript function*/
    const fetch = async () => {
        try {
	    const mpRsp = new Map()
	    console.log('mpRsp.lngth: ' + mpRsp.size);


	    for ( let i = 0; i < rryOsmQuery.length; i++ ) {
		console.log('i: ' + i );
		const query = rryOsmQuery[i];

		console.log('query title: ' + query.title);

		const address = query.query;
		console.log("Fetch:fetch(): address: " + address);

		const res = await get(address);
		console.log("Fetch:fetch(): res.length: "+res.elements.length);
		mpRsp.set(query.title, res.elements)
	    }

	    setMp((mp) => mpRsp);
        } catch (err) {
	    console.error('err.message: ' + err.message);
	    setMp((array) => null);
        }
    };

    useEffect(() => {
	/*effect goes here*/
	fetch();
	/*use an empty dependency array to ensure the hook is running only once*/
	/*TODO study dependency array: https://reactjs.org/docs/hooks-effect.html*/
    }, []);


    if ( mp !== undefined && mp !== null && mp.size > 0 ) {
	/*return a React element*/
	return (
            <>
		<p>JsonOsmQuery</p>
		<MapObject
		    object={mp}
		/>
            </>
	);
    }else{
	return (
            <>
	    <p>JsonOsmQuery</p>
	    <p>Loading...</p>
            </>
	);
    }
};
